#global gitdate 20151027
# temporary build fix:
%define _python_bytecompile_build 0

%bcond_with debug
%define enable_builddocs	0

# Need this for shared objects that reference X Server, or other modules symbols
%define _disable_ld_no_undefined 1

# Alternatives priority for standard libglx.so and mesa libs
%define priority 500

%global __provides_exclude_from %{_datadir}/%{name}-source
%global __requires_exclude_from %{_datadir}/%{name}-source

# Released ABI versions.  Have to keep these manually in sync with the
# source because rpm is a terrible language.
%global ansic_major 0
%global ansic_minor 4
%global videodrv_major 25
%global videodrv_minor 2
%global xinput_major 24
%global xinput_minor 4
%global extension_major 10
%global extension_minor 0

%global pkgname xorg-server

Name: x11-server
Version: 21.1.13
Release:   %mkrel 2
Summary:  X11 servers
Group: System/X11
URL: https://xorg.freedesktop.org
%if 0%{?gitdate}
Source0:   xorg-server-%{gitdate}.tar.xz
%else
Source0:   http://www.x.org/pub/individual/xserver/%{pkgname}-%{version}.tar.xz
Source1:   gitignore
%endif
Source4:   10-quirks.conf
Source5: pclos-setup-keyboard-udev
Source6: 61-x11-input.rules
Source10: xserver.pamd
Source20:  https://svn.exactcode.de/t2/trunk/package/xorg/xorg-server/xvfb-run.sh
Source21:  https://svn.exactcode.de/t2/trunk/package/xorg/xorg-server/xvfb-run.1
Source30:  xserver-sdk-abi-requires.release
Source90: 00-modules.conf
License: GPLv2+ and MIT

Patch200:	0200-xf86-Accept-devices-with-the-hyperv_drm-driver.patch
Patch201:	0001-ephyr-Fix-incompatible-pointer-type-build-error.patch
Patch6: 0001-Fedora-hack-Make-the-suid-root-wrapper-always-start-.patch
Patch900: 0900-Use-a-X-wrapper-that-uses-pam-and-consolehelper-to-g.patch
Patch901: 0901-Don-t-print-information-about-X-Server-being-a-pre-r.patch
Patch902: 0902-Take-width-into-account-when-choosing-default-mode.patch
Patch903: 0903-LED-behavior-fixes.patch
Patch906: 0906-xfree86-need-to-press-Ctrl-Alt-Bksp-twice-to-termina.patch
Patch950: 0001-Force-modesetting-for-AlderLake-P-and-RaptorLake-P-w.patch
Patch951: 0001-Force-modesetting-for-RaptorLake-P-with-UHD-graphics.patch
Patch952: 0001-Force-modesetting-for-more-AlderLake-N-with-UHD-grap.patch
Patch953: 0001-Force-modesetting-for-RocketLake-S-with-UHD-graphics.patch
Patch954: 0001-Force-modesetting-for-ElkhartLake-JasperLake-TigerLa.patch
Patch955: 0001-Fix-modesetting_drv.so-linking.patch

Patch4001: 1001-do-not-crash-if-xv-not-initialized.patch
Patch5009: N_Disable-HW-Cursor-for-cirrus-and-mgag200-kernel-modules.patch
Patch5011: n_raise_default_clients.patch

# Security fixes

Requires: %{name}-xorg
Requires: %{name}-xnest
Requires: %{name}-xvfb

Obsoletes: %{name}-xvnc
Obsoletes: %{name}-xfake
Obsoletes:  %{name}-xdmx

# temp force new gcc
BuildRequires:	gcc
BuildRequires:	binutils
BuildRequires: glibc
BuildRequires: pkgconfig(libnsl)
BuildRequires: pkgconfig(libtirpc)

BuildRequires: git
BuildRequires: libpam-devel
BuildRequires: pkgconfig(egl)
BuildRequires: pkgconfig(fontutil)
BuildRequires: pkgconfig(gbm)
BuildRequires: pkgconfig(dri)
BuildRequires: pkgconfig(gl)
BuildRequires: pkgconfig(libxcvt) 
BuildRequires: pkgconfig(libudev)
BuildRequires: pkgconfig(pciaccess)
BuildRequires: pkgconfig(pixman-1)
BuildRequires: pkgconfig(xau)
BuildRequires: pkgconfig(xaw7)
BuildRequires: pkgconfig(xdmcp)
BuildRequires: pkgconfig(xext)
BuildRequires: pkgconfig(xfixes)
BuildRequires: pkgconfig(xfont2)
BuildRequires: pkgconfig(xi)
BuildRequires: pkgconfig(xkbfile)
BuildRequires: pkgconfig(xmu)
BuildRequires: pkgconfig(xorg-macros)
BuildRequires: pkgconfig(xpm)
BuildRequires: pkgconfig(xrender)
BuildRequires: pkgconfig(xres)
BuildRequires: pkgconfig(xtrans)
BuildRequires: pkgconfig(xv)
BuildRequires: x11-proto-devel

# for ./hw/xwin/glx/gen_gl_wrappers.py:
%define _python_bytecompile_errors_terminate_build 0

# Probably only needed if we change .l or .y files, but let's have them anyway:
BuildRequires: byacc
BuildRequires: flex

# for xkbcomp patch
BuildRequires: pkgconfig(libcrypto)
BuildRequires: pkgconfig(dbus-1)
BuildRequires: pkgconfig(xtst)
BuildRequires: pkgconfig(epoxy)
BuildRequires: pkgconfig(xshmfence)
BuildRequires: pkgconfig(libunwind)
BuildRequires: pkgconfig(xcb-aux)
BuildRequires: pkgconfig(xcb-image)
BuildRequires: pkgconfig(xcb-icccm)
BuildRequires: pkgconfig(xcb-keysyms)
BuildRequires: pkgconfig(xcb-renderutil)

%if %{enable_builddocs}
BuildRequires: doxygen
BuildRequires: fop
BuildRequires: xmlto
BuildRequires: pkgconfig(xorg-sgml-doctools)
%endif

%description
X.Org X11 X server


%package common
Summary: Xorg server common files
Group: System/X11
License: MIT
Provides: XFree86 = 7.0.0
Requires: rgb
# for 'fixed' and 'cursor' fonts
Requires: x11-font-misc-misc
Requires: x11-font-cursor-misc
Requires: x11-font-alias
Requires: x11-data-xkbdata
Requires: xkbcomp
Requires: udev
Requires: mesa
Requires(post): update-alternatives
Requires(postun): update-alternatives

Conflicts: x11-driver-video-nvidia71xx
Conflicts: x11-driver-video-fglrx

Provides: xserver-abi(ansic-%{ansic_major}) = %{ansic_minor}
Provides: xserver-abi(videodrv-%{videodrv_major}) = %{videodrv_minor}
Provides: xserver-abi(xinput-%{xinput_major}) = %{xinput_minor}
Provides: xserver-abi(extension-%{extension_major}) = %{extension_minor}
Provides: xserver-abi(videodrv) = %{videodrv_major}.%{videodrv_minor}

%description common
X server common files

%package xorg
Summary: Xorg X server
Group: System/X11
License: MIT
Requires: x11-server-common = %{version}-%{release}
Requires: x11-data-xkbdata
Requires: x11-font-alias
Requires: libx11-common
Requires: x11-driver-input-libinput
Requires: libxfont

Obsoletes: glamor
Obsoletes: lib64glamor0
Provides: glamor = %version-%release
Provides: lib64glamor = %version-%release
Obsoletes: x11-driver-video-modesetting
Provides: x11-driver-video-modesetting = %version-%release

 #temp to provide easy upgrading
Provides: xserver-abi(videodrv-24)


%description xorg
X.org X11 is an open source implementation of the X Window System.  It
provides the basic low level functionality which full fledged
graphical user interfaces (GUIs) such as GNOME and KDE are designed
upon.


%package xnest
Summary: A nested server
Group: System/X11
License: MIT
Requires: x11-server-common = %{version}-%{release}

%description xnest
Xnest is an X server which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.  It
is a very useful tool for developers who wish to test their
applications without running them on their real X server.


%package xvfb
Summary: A X Windows System virtual framebuffer X server
Group: System/X11
# xvfb-run is GPLv2, rest is MIT
License: MIT and GPLv2
Requires: x11-server-common = %{version}-%{release}
Requires: xauth


%description xvfb
Xvfb (X Virtual Frame Buffer) is an X server that is able to run on
machines with no display hardware and no physical input devices.
Xvfb simulates a dumb framebuffer using virtual memory.  Xvfb does
not open any devices, but behaves otherwise as an X display.  Xvfb
is normally used for testing servers.


%package xephyr
Summary: A nested server
Group: System/X11
License: MIT
Requires: x11-server-common = %{version}-%{release}

%description xephyr
Xephyr is an X server which has been implemented as an ordinary
X application.  It runs in a window just like other X applications,
but it is an X server itself in which you can run other software.  It
is a very useful tool for developers who wish to test their
applications without running them on their real X server.  Unlike
Xnest, Xephyr renders to an X image rather than relaying the
X protocol, and therefore supports the newer X extensions like
Render and Composite.


%package devel
Summary: SDK for X server driver module development
Group: Development/X11
License: MIT

%define oldxorgnamedevel  %mklibname xorg-x11
Requires: libpixman-1-devel
Requires: libpciaccess-devel
Requires: libxkbfile-devel
Requires: libxext-devel >= 1.1
Requires: pkgconfig(xfont2)
# pkgconfig file needs dri.pc:
Requires: GL-devel

%description devel
The SDK package provides the developmental files which are necessary for
developing X server driver modules, and for compiling driver modules
outside of the standard X11 source code tree.  Developers writing video
drivers, input drivers, or other X modules should install this package.


%package source
Summary: Xserver source code required to build VNC server (Xvnc)
Group: Development/X11
License: MIT

%description source
Xserver source code needed to build VNC server (Xvnc)


%prep
%setup -q -n %{pkgname}-%{version}

%autopatch -p1

# check the ABI in the source against what we expect.
getmajor() {
   grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
   tr '(),' '   ' | awk '{ print $4 }'
}

getminor() {
   grep -i ^#define.ABI.$1_VERSION hw/xfree86/common/xf86Module.h |
   tr '(),' '   ' | awk '{ print $5 }'
}

test `getmajor ansic` == %{ansic_major}
test `getminor ansic` == %{ansic_minor}
test `getmajor videodrv` == %{videodrv_major}
test `getminor videodrv` == %{videodrv_minor}
test `getmajor xinput` == %{xinput_major}
test `getminor xinput` == %{xinput_minor}
test `getmajor extension` == %{extension_major}
test `getminor extension` == %{extension_minor}


%build

export LDFLAGS="-L/usr/lib64/libglvnd/ $LDFLAGS"

%ifnarch %{ix86} x86_64
%global no_int10 --disable-vbe --disable-int10-module
%endif
%global kdrive --enable-kdrive --enable-xephyr 
%global xservers --enable-xvfb --enable-xnest %{kdrive} --enable-xorg
%global default_font_path "catalogue:/etc/X11/fontpath.d,built-ins"
%global dri_flags --enable-dri2 --enable-dri3 --enable-suid-wrapper --enable-glamor
%global bodhi_flags --with-vendor-name="PCLinuxOS"

%if %with debug
CFLAGS='-DBUILDDEBUG -O0 -g3' \
%endif
autoreconf -f -v --install || exit 1
export CFLAGS+="%{optflags} -Wno-declaration-after-statement -Wno-maybe-uninitialized -Wno-unused-result -Wno-logical-op"
%configure2_5x %{xservers} \
		--with-log-dir=%{_logdir} \
		--enable-dependency-tracking \
		%{?no_int10} --with-int10=x86emu \
		--with-default-font-path=%{default_font_path} \
		--with-module-dir=%{_libdir}/xorg/modules \
		--with-vendor-web="https://pclinuxos.com" \
		%if %{with debug}
		--enable-debug \
		%else
		--disable-debug \
		%endif
		--with-builderstring="Build ID: %{name} %{version}-%{release}" \
		--without-dtrace \
		--disable-xselinux --enable-record --enable-present \
		--enable-xcsecurity \
		--enable-config-udev \
		--disable-strict-compilation \
		--enable-dpms \
		--disable-install-setuid \
		--enable-pam \
		%{dri_flags} %{?bodhi_flags} \
		--with-sha1=libcrypto \
		--disable-systemd-logind \
		--with-systemd-daemon=no

pushd include && make xorg-server.h dix-config.h xorg-config.h && popd
%make_build

%install
%make_install

mkdir -p $RPM_BUILD_ROOT%{_libdir}/xorg/modules/{drivers,input}

mkdir -p %{buildroot}%{_sysconfdir}/X11/
ln -s %{_bindir}/Xorg %{buildroot}%{_sysconfdir}/X11/X
ln -sf %{_libexecdir}/Xorg.wrap %{buildroot}%{_bindir}/X

mkdir -p %{buildroot}%{_sysconfdir}/pam.d
install -m 644 %{SOURCE10} $RPM_BUILD_ROOT%{_sysconfdir}/pam.d/xserver
mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
touch %{buildroot}%{_sysconfdir}/security/console.apps/xserver

mkdir -p $RPM_BUILD_ROOT%{_datadir}/X11/xorg.conf.d
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/X11/xorg.conf.d

# make sure the (empty) /etc/X11/xorg.conf.d is there, system-setup-keyboard
# relies on it more or less.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/xorg.conf.d
 
mkdir -p %{buildroot}%{_sysconfdir}/X11/app-defaults
mkdir -p %{buildroot}%{_sysconfdir}/X11/fontpath.d

# move README.compiled outside compiled/ dir, so there won't be any problem with x11-data-xkbdata
mv -f %{buildroot}%{_datadir}/X11/xkb/compiled/README.compiled %{buildroot}%{_datadir}/X11/xkb/

# (anssi) manage proprietary drivers
install -d -m755 %{buildroot}%{_sysconfdir}/ld.so.conf.d/GL
cat > %{buildroot}%{_sysconfdir}/ld.so.conf.d/GL/standard.conf << EOF
# This file is knowingly empty since the libraries are in standard search
# path. Please do not remove this file.
EOF
touch %{buildroot}%{_sysconfdir}/ld.so.conf.d/GL.conf

mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}/lib/udev/rules.d/
install -m 0755 %{SOURCE5} %{buildroot}/sbin/pclos-setup-keyboard
install -m 0644 %{SOURCE6} %{buildroot}/lib/udev/rules.d

install -m 755 %{SOURCE30} $RPM_BUILD_ROOT%{_bindir}/xserver-sdk-abi-requires

install -m 0755 %{SOURCE20} $RPM_BUILD_ROOT%{_bindir}/xvfb-run

# Make the source package
%global xserver_source_dir %{_datadir}/x11-server-source
%global inst_srcdir %{buildroot}/%{xserver_source_dir}
mkdir -p %{inst_srcdir}/{Xext,xkb,GL,hw/{xquartz/bundle,xfree86/common}}
mkdir -p %{inst_srcdir}/{man,doc}
cp {,%{inst_srcdir}/}hw/xquartz/bundle/cpprules.in
cp {,%{inst_srcdir}/}man/Xserver.man
cp {,%{inst_srcdir}/}doc/smartsched
cp {,%{inst_srcdir}/}xserver.ent.in
cp {,%{inst_srcdir}/}hw/xfree86/Xorg.sh.in
cp xkb/README.compiled %{inst_srcdir}/xkb
cp hw/xfree86/xorgconf.cpp %{inst_srcdir}/hw/xfree86

install -m 0755 %{SOURCE21} $RPM_BUILD_ROOT%{_mandir}/man1/xvfb-run.1
install -m 0644 %{SOURCE90} $RPM_BUILD_ROOT/usr/share/X11/xorg.conf.d/

find . -type f | egrep '.*\.(c|h|am|ac|inc|m4|h.in|pc.in|man.pre|pl|txt)$' |
xargs tar cf - | (cd %{inst_srcdir} && tar xf -)
find %{inst_srcdir}/hw/xfree86 -name \*.c -delete

# Remove unwanted files/dirs
{
    find $RPM_BUILD_ROOT -type f -name '*.la' | xargs rm -f -- || :
# wtf
%ifnarch %{ix86} x86_64
    rm -f $RPM_BUILD_ROOT%{_libdir}/xorg/modules/lib{int10,vbe}.so
%endif
}
 
%post common
%{_sbindir}/update-alternatives \
	--install %{_sysconfdir}/ld.so.conf.d/GL.conf gl_conf %{_sysconfdir}/ld.so.conf.d/GL/standard.conf %{priority}

# (anssi)
%triggerun common -- %{name}-common < 1.3.0.0-17
[ $1 -eq 2 ] || exit 0 # do not run if downgrading
current_glconf="$(readlink -e %{_sysconfdir}/ld.so.conf.d/GL.conf)"
if [ "${current_glconf#*mesa}" == "gl1.conf" ]; then
	%{_sbindir}/update-alternatives --set gl_conf %{_sysconfdir}/ld.so.conf.d/GL/standard.conf
else
	%{_sbindir}/update-alternatives --set gl_conf "${current_glconf}"
fi
true

%postun common
if [ ! -f %{_sysconfdir}/ld.so.conf.d/GL/standard.conf ]; then
	/usr/sbin/update-alternatives --remove gl_conf %{_sysconfdir}/ld.so.conf.d/GL/standard.conf
fi

%files

%files common
%dir %{_libdir}/xorg/modules
%dir %{_sysconfdir}/X11
%dir %{_sysconfdir}/X11/app-defaults
%dir %{_sysconfdir}/X11/fontpath.d
%dir %{_sysconfdir}/ld.so.conf.d/GL
%dir %{_sysconfdir}/X11/xorg.conf.d
%ghost %{_sysconfdir}/ld.so.conf.d/GL.conf
%{_sysconfdir}/ld.so.conf.d/GL/standard.conf
%{_bindir}/gtf
/sbin/pclos-setup-keyboard
/lib/udev/rules.d/61-x11-input.rules
%{_libdir}/xorg/modules/*
%{_libdir}/xorg/protocol.txt
%{_datadir}/X11/xkb/README.compiled
%{_mandir}/man1/gtf.*
%{_mandir}/man4/*

%global Xorgperms %attr(4755, root, root)

%files xorg
%{_bindir}/X
%{_bindir}/Xorg
%{_libexecdir}/Xorg
%{Xorgperms} %{_libexecdir}/Xorg.wrap
%attr(4755,root,root)%{_bindir}/Xwrapper
%{_sysconfdir}/X11/X
%{_sysconfdir}/pam.d/xserver
%{_sysconfdir}/security/console.apps/xserver
%{_mandir}/man1/Xorg.1*
%{_mandir}/man1/Xorg.wrap.1*
%{_mandir}/man1/Xserver.1*
%{_mandir}/man5/Xwrapper.config.5*
%{_mandir}/man5/xorg.conf.5*
%{_mandir}/man5/xorg.conf.d.5*
%{_datadir}/X11/xorg.conf.d/00-modules.conf
%{_datadir}/X11/xorg.conf.d/10-quirks.conf

%files xnest
%{_bindir}/Xnest
%{_mandir}/man1/Xnest.1*

%files xvfb
%{_bindir}/Xvfb
%{_bindir}/xvfb-run
%{_mandir}/man1/Xvfb.1*
%{_mandir}/man1/xvfb-run.1*

%files xephyr
%{_bindir}/Xephyr
%{_mandir}/man1/Xephyr.1*

%files devel
%{_bindir}/xserver-sdk-abi-requires
%{_libdir}/pkgconfig/xorg-server.pc
%dir %{_includedir}/xorg
%{_includedir}/xorg/*.h
%{_datadir}/aclocal/xorg-server.m4

%files source
%{xserver_source_dir}


%changelog
* Thu Apr 18 2024 tex - 12.1.13-2pclos2024
- adjust patchset

* Fri Apr 12 2024 tex - 21.1.13-1pclos2024
- new version

* Thu Apr 04 2024 tex - 21.1.12-1pclos2024
- new version
